All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Pages
PeriodicTorsionForce Class Reference

This class implements an interaction between groups of four particles that varies periodically with the torsion angle between them. More...

`#include <PeriodicTorsionForce.h>`

Inheritance diagram for PeriodicTorsionForce:

## Public Member Functions

| PeriodicTorsionForce ()
| Create a PeriodicTorsionForce. More...
int | getNumTorsions () const
| Get the number of periodic torsion terms in the potential function. More...
int | addTorsion (int particle1, int particle2, int particle3, int particle4, int periodicity, double phase, double k)
| Add a periodic torsion term to the force field. More...
void | getTorsionParameters (int index, int &particle1, int &particle2, int &particle3, int &particle4, int &periodicity, double &phase, double &k) const
| Get the force field parameters for a periodic torsion term. More...
void | setTorsionParameters (int index, int particle1, int particle2, int particle3, int particle4, int periodicity, double phase, double k)
| Set the force field parameters for a periodic torsion term. More...
void | updateParametersInContext (Context &context)
| Update the per-torsion parameters in a Context to match those stored in this Force object. More...
bool | usesPeriodicBoundaryConditions () const
| Returns whether or not this force makes use of periodic boundary conditions. More...
Public Member Functions inherited from Force
| Force ()
virtual | ~Force ()
int | getForceGroup () const
| Get the force group this Force belongs to. More...
void | setForceGroup (int group)
| Set the force group this Force belongs to. More...

## Protected Member Functions

ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System. More...
Protected Member Functions inherited from Force
ForceImpl & | getImplInContext (Context &context)
| Get the ForceImpl corresponding to this Force in a Context. More...
ContextImpl & | getContextImpl (Context &context)
| Get the ContextImpl corresponding to a Context. More...

## Detailed Description

This class implements an interaction between groups of four particles that varies periodically with the torsion angle between them.

To use it, create a PeriodicTorsionForce object then call addTorsion() once for each torsion. After a torsion has been added, you can modify its force field parameters by calling setTorsionParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

## Constructor & Destructor Documentation

PeriodicTorsionForce | ( |  | ) |

Create a PeriodicTorsionForce.

## Member Function Documentation

int addTorsion | ( | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | int | particle4,
|  | int | periodicity,
|  | double | phase,
|  | double | k
| ) |  |

Add a periodic torsion term to the force field.

Parameters

  particle1 | the index of the first particle forming the torsion
  particle2 | the index of the second particle forming the torsion
  particle3 | the index of the third particle forming the torsion
  particle4 | the index of the fourth particle forming the torsion
  periodicity | the periodicity of the torsion
  phase | the phase offset of the torsion, measured in radians
  k | the force constant for the torsion

Returns
  the index of the torsion that was added

ForceImpl* createImpl | ( |  | ) | const

protectedvirtual

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

int getNumTorsions | ( |  | ) | const

inline

Get the number of periodic torsion terms in the potential function.

void getTorsionParameters | ( | int | index,
|  | int & | particle1,
|  | int & | particle2,
|  | int & | particle3,
|  | int & | particle4,
|  | int & | periodicity,
|  | double & | phase,
|  | double & | k
| ) |  | const

Get the force field parameters for a periodic torsion term.

Parameters

  index | the index of the torsion for which to get parameters
  particle1 | the index of the first particle forming the torsion
  particle2 | the index of the second particle forming the torsion
  particle3 | the index of the third particle forming the torsion
  particle4 | the index of the fourth particle forming the torsion
  periodicity | the periodicity of the torsion
  phase | the phase offset of the torsion, measured in radians
  k | the force constant for the torsion

void setTorsionParameters | ( | int | index,
|  | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | int | particle4,
|  | int | periodicity,
|  | double | phase,
|  | double | k
| ) |  |

Set the force field parameters for a periodic torsion term.

Parameters

  index | the index of the torsion for which to set parameters
  particle1 | the index of the first particle forming the torsion
  particle2 | the index of the second particle forming the torsion
  particle3 | the index of the third particle forming the torsion
  particle4 | the index of the fourth particle forming the torsion
  periodicity | the periodicity of the torsion
  phase | the phase offset of the torsion, measured in radians
  k | the force constant for the torsion

void updateParametersInContext | ( | Context & | context | ) |

Update the per-torsion parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setTorsionParameters() to modify this object's parameters, then call updateParametersInContext() to copy them over to the Context.

The only information this method updates is the values of per-torsion parameters. The set of particles involved in a torsion cannot be changed, nor can new torsions be added.

bool usesPeriodicBoundaryConditions | ( |  | ) | const

inlinevirtual

Returns whether or not this force makes use of periodic boundary conditions.

Returns
  true if force uses PBC and false otherwise

Reimplemented from Force.

The documentation for this class was generated from the following file:

- PeriodicTorsionForce.h